#!/usr/bin/env python

import user, os, sys, getopt, exceptions

def setup_env():
    if "REPET_PATH" in os.environ.keys():
        sys.path.append( os.environ["REPET_PATH"] )
setup_env()

from pyRepet.launcher.programLauncher import *
from pyRepet.parser.Parser import *

#------------------------------------------------------------------------------

def help():

    print ""
    print "usage: ",sys.argv[0],"[ options ]"
    print "options:"
    print "     -h: this help"
    print "     -i: input filename (fasta)"
    print "     -o: output filename (default=inFileName+'.TRF.set')"
    print "     -c: clean"
    print ""

#------------------------------------------------------------------------------

def main():

    inFileName = ""
    outFileName = ""
    clean = "no"

    try:
        opts,args=getopt.getopt(sys.argv[1:],"hi:o:c")
    except getopt.GetoptError:
        help()
        sys.exit(1)
    for o,a in opts:
        if o == "-h":
            help()
            sys.exit(0)
        elif o == "-i":
            inFileName = a
        elif o == "-o":
            outFileName = a
        elif o == "-c":
            clean = "yes"

    if inFileName == "":
        print "*** Error: missing compulsory options"
        help()
        sys.exit(1)

    print "\nbeginning of %s" % (sys.argv[0].split("/")[-1])
    sys.stdout.flush()

    # WARNING: up to know, TRF doesn't return EXIT_SUCCESS when finished
##    pL = programLauncher( inFileName )
##    pL.launchTRF( html="no" )

    prg = "trf"
    cmd = prg
    cmd += " %s 2 3 5 80 10 20 15 -h -d" % ( inFileName )
    log = os.system( cmd )

    # WARNING: the function that parses TRF html outputs has bugs in it
##    parser = TrfParser( outFileName )
##    parser.html2set( inFileName + ".2.3.5.80.10.20.15.1.txt.html" )

    if outFileName == "":
        outFileName = inFileName + ".TRF.set"

    parser = TrfParser( inFileName, "dat", outFileName )
    parser.dat2set( inFileName + ".2.3.5.80.10.20.15.dat" )
    if clean == "yes":
        parser.clean()

    print "%s finished successfully\n" % (sys.argv[0].split("/")[-1])
    sys.stdout.flush()

    return 0

#------------------------------------------------------------------------------

if __name__ == '__main__':
    main()
