class IHmmOutputProcessing:
    
    """
    Interface for processing of an hmm search output.
    """
    
    def readHmmOutput( self, file ):
        """
        read an hmm output from a file, return a HmmOutput object
        
        @param file:  handle of file generated by software searching hmm profiles
        @type file: handle of file
        """
        pass
       
       
    def writeHmmOutputToAlignFile (self, HmmOutput, fout):
        """
        write a align file from a HmmOutput object
        @param fout:  handle of align file
        @type fout: handle of file
        @param HmmOutput:  HmmOutput object in fact a list of hmmOutput containing datas required
        @type HmmOutput: HmmOutput object
        """
        pass
    
    def readHmmOutputsAndWriteAlignFile(self, inputFile, outputFile):
        """
        read the file generated by software and write the corresponding align file
        """
        pass        
    
    